 'Robotattiny13.bas Version 1.01 05 / 2017

' Mini Robot ATtiny13A  version DIL & servo moteurs
' Contrle Pont H L293D

'  8-pins ATTiny13 AVR risk processor soic 5mm packaged  !!
'  processeur risk ATTiny13 en boitier soic 5mm un must !!
'  outputs have a 10K pull up to 5V and are active low

'Programmation des Bytes fusibles: No Memory look, Enable Serial Programming,
'Watchdog Off Divide clock by 8 Off, Int RC Oscillator 4,8 MHz Start-Up14CK+65ms
'BOD disable  External Reset Enable
'$prog &H79 , &HFF                                           'fuse bytes.


$regfile = "attiny13.dat"

$hwstack = 10
$swstack = 18
$framesize = 24

'les sortie sont maintenues a 5v par des rsistance de 10K et actives  0V



Dim Nb As Byte
Dim Nb1 As Byte

'Input - Entre
Ddrb.3 = 0                                                  'IS471F IR sensor


'Rduction de la consomation   reduction in power consumption
Didr0 = Bits(ain1d , Ain0d)                                 'Disable digital input buffer on the AIN1/0 pin
Set Acsr.acd                                                'Switch off  the power to the Analog Comparator
'alternative: Stop Ac
Reset Acsr.acbg                                             'Disable Analog Comparator Bandgap Select
Reset Adcsra.aden                                           'Switch off ADC
'alternative: Stop Adc


'outputs - sorties  motors control - commande des moteurs
'M1 right motor command      commande du moteur droit M1
'IN1A = PB2       IN2A =PB4
'M2 left motor command      commande du moteur gauche M2
'IN3A = PB1       IN4A =PB0

'outputs configuration    configuration des sorties
Ddrb.2 = 1
Ddrb.4 = 1
Ddrb.1 = 1
Ddrb.0 = 1
'***************** StartUp Dmarrage *****************
'Init= stopped for 5 seconds  l'arrt pendant 5 secondes
Portb.2 = 0
Portb.4 = 0
Portb.1 = 0
Portb.0 = 0
Wait 5

Do
'*-------------------------------------------------------------------------*
'PWM to control the motors slowly MLI pour commander les moteurs moins vite
'Nb is used to count the number of pass of the bot for making variable strategy
'Nb sert  compter les passages du bot pour changer de stratgie
'run forward marche avant
   Portb.2 = 1                                              'P2   IN1A = 1
    'Waitms 50                                              slowing sample
   Portb.4 = 0                                              'P1   IN3A = 0
    'Waitms 50                                               'example de ralentissement
   Portb.1 = 0                                              'P4   IN2A = 0
    'Waitms 50
   Portb.0 = 1                                              'P0   IN4A = 1
    'Waitms 50

'To move right must be balanced engines you need to find the value of yours
'Pour avancer droit il faut quilibrer un des  moteurs
'vous devez trouver la valeur des  votres
 'ralentissment d'un seul moteur slowing only one motor
   'portb.4 = 1                                             'P4 off - arrt
   'Waitus 20                                                '20s

   'Portb.3 = 1
   'Portb.4 = 0                                              ' off - arrt
   'Waitms 1

'obstacle detection by IR sensor - obstacle dtect par le capteur IR  ?
If Pinb.3 = 0 And Nb <= 5 Then                              'Nb < 6  repete repeat
Nb = Nb + 1
Gosub Arret
Gosub Recule
Gosub Arret
Gosub Gauche

End If
If Pinb.3 = 0 And Nb = 6 Then                               ' pass 6 passage 6
Gosub Arret
Gosub Recule
Gosub Arret
Gosub Demitour                                              ' alors  demi-tour then half-turn
End If
Waitms 30

If Pinb.3 = 0 And Nb1 <> 0 Then                             'on essais a droite we try to right
Gosub Arret
Gosub Recule
Gosub Arret
Gosub Droite
End If
Waitms 30

Loop
End
'Fin du programme principal  Main program End



'*********************** Sous Programmes ************************

'********** obstacle detected - obstacle dtect **********
' break                      frein
   Arret:
   Portb.2 = 0                                              'P2   IN1A = 0
   Portb.1 = 0                                              'P1   IN3A = 0
   Portb.4 = 0                                              'P4   IN2A = 0
   Portb.0 = 0                                              'P0   IN4A = 0
   Waitms 30
Return

Recule:
   Portb.2 = 0                                              'P2 off - arret
   Portb.4 = 1                                              'P4 on - marche
   Portb.1 = 1                                              'P2 on - marche
   Portb.0 = 0                                              'P4 off - arret
   Wait 1                                                   'secondes
Return

Droite:
Nb1 = Nb1 - 1

      Portb.2 = 0                                           'we try to right
      Portb.4 = 1                                           'on essaie  droite
      Portb.1 = 0
      Portb.0 = 1
      Waitms 800
If Nb1 = 0 Then Nb = 0
Return

Gauche:
                                                            'we try to left
      Portb.2 = 1                                           'on essaie  gauche
      Portb.4 = 0
      Portb.1 = 1
      Portb.0 = 0
      Waitms 900

Return

Demitour:
      Nb = 7
      Portb.2 = 1
      Portb.4 = 0
      Portb.1 = 1
      Portb.0 = 0
      Wait 2
Nb1 = 6
Return
'*************have Fun   Ammusez vous******************